/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.geodata.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="GEODATA_ORT.UK",
     query="SELECT o FROM GeodataOrt o WHERE "

                         + "o"
                +".ortsname"
              +" = ?1"

             +" AND "         + "o"
                +".ortsteilname"
              +" = ?2"

     ,
   hints = {
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="GEODATA_ORT.All",
     query="SELECT obj FROM GeodataOrt obj",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
         ,   @javax.persistence.NamedQuery(
     name="GEODATA_ORT.OrtsnameAndOrtsteilname",
     query="SELECT obj FROM GeodataOrt obj WHERE (obj.ortsname IS NULL AND LENGTH(?1) = 0 OR UPPER(obj.ortsname) = UPPER(?1)) AND (obj.ortsteilname IS NULL AND LENGTH(?2) = 0 OR UPPER(obj.ortsteilname) = UPPER(?2))",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "GEODATA_ORT")
// @javax.persistence.IdClass(GeodataOrtPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    
public
 class GeodataOrt
extends AbstractGeodataOrt
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public GeodataOrt() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public GeodataOrt(GeodataOrt original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "geodata_ort_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "GeodataOrt")
    @javax.persistence.TableGenerator(name = "GeodataOrt", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "GeodataOrt", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient GeodataOrtPK pkCache;

  @Override
  public GeodataOrtPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new GeodataOrtPK(getId());
    }

    return pkCache;
  }

  public static <E extends GeodataOrt> java.util.Map<GeodataOrtPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<GeodataOrtPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends GeodataOrt> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedLatitude = false;
          hasChangedLongitude = false;
          hasChangedOrtsname = false;
          hasChangedOrtsteilname = false;
  

          hasChangedGeodataPlzs = false;
      

    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
    @javax.persistence.Column(name = "LATITUDE", nullable = GeodataOrtConstants.LATITUDE_NULLABLE)
    
  protected java.lang.Double latitude =  null;

  @javax.persistence.Transient
  protected boolean hasChangedLatitude = false;

  public boolean hasChangedLatitude(){
    return hasChangedLatitude;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertLatitude = false;
     @javax.persistence.Transient
     private transient java.lang.Double wertNachLadenLatitude;
  
  /**
   * 
   *
   * getter for GEODATA_ORT.LATITUDE
   */
  @javax.annotation.Nullable   @Override   public  java.lang.Double getLatitude() {
        return latitude;
      }

  /**
   * 
   *
   * setter for GEODATA_ORT.LATITUDE
   *
   * @param latitude
   */
  @Override   public void setLatitude(@javax.annotation.Nullable  java.lang.Double latitude) {

       resetTkCache();
                  java.lang.Double latitudeInternal = latitude;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.latitude
      , latitudeInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedLatitude |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("latitude");
      }


             if (!isSeitLadenVeraendertLatitude) {
          isSeitLadenVeraendertLatitude = thisAttributChanged;
         if (isSeitLadenVeraendertLatitude){
           wertNachLadenLatitude=this.latitude;
         }
       }
      

       this.latitude = latitudeInternal;

         }

        
    @javax.persistence.Column(name = "LONGITUDE", nullable = GeodataOrtConstants.LONGITUDE_NULLABLE)
    
  protected java.lang.Double longitude =  null;

  @javax.persistence.Transient
  protected boolean hasChangedLongitude = false;

  public boolean hasChangedLongitude(){
    return hasChangedLongitude;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertLongitude = false;
     @javax.persistence.Transient
     private transient java.lang.Double wertNachLadenLongitude;
  
  /**
   * 
   *
   * getter for GEODATA_ORT.LONGITUDE
   */
  @javax.annotation.Nullable   @Override   public  java.lang.Double getLongitude() {
        return longitude;
      }

  /**
   * 
   *
   * setter for GEODATA_ORT.LONGITUDE
   *
   * @param longitude
   */
  @Override   public void setLongitude(@javax.annotation.Nullable  java.lang.Double longitude) {

       resetTkCache();
                  java.lang.Double longitudeInternal = longitude;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.longitude
      , longitudeInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedLongitude |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("longitude");
      }


             if (!isSeitLadenVeraendertLongitude) {
          isSeitLadenVeraendertLongitude = thisAttributChanged;
         if (isSeitLadenVeraendertLongitude){
           wertNachLadenLongitude=this.longitude;
         }
       }
      

       this.longitude = longitudeInternal;

         }

        
      @javax.persistence.Column(name = "ORTSNAME", nullable = GeodataOrtConstants.ORTSNAME_NULLABLE, length=GeodataOrtConstants.ORTSNAME_MAX_LENGTH)
        
  protected java.lang.String ortsname =  null;

  @javax.persistence.Transient
  protected boolean hasChangedOrtsname = false;

  public boolean hasChangedOrtsname(){
    return hasChangedOrtsname;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertOrtsname = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenOrtsname;
  
  /**
   * 
   *
   * getter for GEODATA_ORT.ORTSNAME
   */
    @Override   public  java.lang.String getOrtsname() {
        return ortsname;
      }

  /**
   * 
   *
   * setter for GEODATA_ORT.ORTSNAME
   *
   * @param ortsname
   */
  @Override   public void setOrtsname( java.lang.String ortsname) {

       resetTkCache();
                  
                          java.lang.String ortsnameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(ortsname, GeodataOrtConstants.ORTSNAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ortsname
      , ortsnameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedOrtsname |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ortsname");
      }


             if (!isSeitLadenVeraendertOrtsname) {
          isSeitLadenVeraendertOrtsname = thisAttributChanged;
         if (isSeitLadenVeraendertOrtsname){
           wertNachLadenOrtsname=this.ortsname;
         }
       }
      

       this.ortsname = ortsnameInternal;

         }

        
  @javax.persistence.Column(name = "ORTSTEILNAME", nullable = GeodataOrtConstants.ORTSTEILNAME_NULLABLE, length=GeodataOrtConstants.ORTSTEILNAME_MAX_LENGTH)
        
  protected java.lang.String ortsteilname =  null;

  @javax.persistence.Transient
  protected boolean hasChangedOrtsteilname = false;

  public boolean hasChangedOrtsteilname(){
    return hasChangedOrtsteilname;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertOrtsteilname = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenOrtsteilname;
  
  /**
   * 
   *
   * getter for GEODATA_ORT.ORTSTEILNAME
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getOrtsteilname() {
        return ortsteilname;
      }

  /**
   * 
   *
   * setter for GEODATA_ORT.ORTSTEILNAME
   *
   * @param ortsteilname
   */
  @Override   public void setOrtsteilname(@javax.annotation.Nullable  java.lang.String ortsteilname) {

       resetTkCache();
                  
                          java.lang.String ortsteilnameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(ortsteilname, GeodataOrtConstants.ORTSTEILNAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ortsteilname
      , ortsteilnameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedOrtsteilname |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ortsteilname");
      }


             if (!isSeitLadenVeraendertOrtsteilname) {
          isSeitLadenVeraendertOrtsteilname = thisAttributChanged;
         if (isSeitLadenVeraendertOrtsteilname){
           wertNachLadenOrtsteilname=this.ortsteilname;
         }
       }
      

       this.ortsteilname = ortsteilnameInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */
  /**
   * Beziehung N:M (bidirektional, fuehrend) zu GeodataPlzs
   */
  @javax.persistence.ManyToMany(fetch=javax.persistence.FetchType.LAZY)
  @javax.persistence.JoinTable(name="GEODATA_ORT_GEODATA_PLZ",
     joinColumns = {@javax.persistence.JoinColumn(name="GEODATA_ORT_ID", referencedColumnName="geodata_ort_id")},
     inverseJoinColumns = {@javax.persistence.JoinColumn(name="GEODATA_PLZ_ID", referencedColumnName="GEODATA_PLZ_ID")}) 
  protected java.util.Set<de.ivu.elect.business.geodata.entity.GeodataPlz> geodataPlzs;

  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  @Override
  public java.util.Set<de.ivu.elect.business.geodata.entity.GeodataPlz> getGeodataPlzs(){
    if (geodataPlzs == null){
      return  java.util.Collections.<de.ivu.elect.business.geodata.entity.GeodataPlz>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.geodata.entity.GeodataPlz>emptySet());
    }
    return java.util.Collections.<de.ivu.elect.business.geodata.entity.GeodataPlz>unmodifiableSet(this.geodataPlzs);
  }


  @javax.persistence.Transient
  private boolean hasChangedGeodataPlzs = false;

  public boolean hasChangedGeodataPlzs() {
    return hasChangedGeodataPlzs;
  }


 /**
  * Hinzufuegen von de.ivu.elect.business.geodata.entity.GeodataPlz
  */
  @Override
  public void addGeodataPlz(de.ivu.elect.business.geodata.entity.GeodataPlz geodataPlz){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (geodataPlz != null){
          if (this.geodataPlzs == null){
            this.geodataPlzs = new java.util.HashSet<>();
          }

          boolean isChanged = this.geodataPlzs.add(geodataPlz);

          if(!hasChangedGeodataPlzs) {
            hasChangedGeodataPlzs =  isChanged;
          }

              // andere Seite der Beziehung aktualisieren
          geodataPlz.addGeodataOrt(this);
                  }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.geodata.entity.GeodataPlz
   */
  @Override
  public void removeGeodataPlz(de.ivu.elect.business.geodata.entity.GeodataPlz geodataPlz){
    try {
      if (!updateRelationship){
        updateRelationship = true;
        if (geodataPlz != null){
          if (this.geodataPlzs != null){
            boolean isChanged = this.geodataPlzs.remove(geodataPlz);

            if(!hasChangedGeodataPlzs) {
              hasChangedGeodataPlzs =  isChanged;
            }
          }

                    // andere Seite der Beziehung aktualisieren
          if (geodataPlz != null) {
            geodataPlz.removeGeodataOrt(this);
          }
                  }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen  de.ivu.elect.business.geodata.entity.GeodataPlz
  */
   @Override
   public void removeAllGeodataPlzs(){
     java.util.Set<de.ivu.elect.business.geodata.entity.GeodataPlz> toRemove = new java.util.HashSet<>(getGeodataPlzs());

     for (   de.ivu.elect.business.geodata.entity.GeodataPlz entity:toRemove){
       removeGeodataPlz(entity);
     }
   }


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("GeodataOrt:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(GeodataOrt other){
                             other.latitude = this.latitude;
                                other.longitude = this.longitude;
                                other.ortsname = this.ortsname;
                                other.ortsteilname = this.ortsteilname;
           
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(GeodataOrt.class)){
        copyEntityAttributesUsingSetter((GeodataOrt) other.castTo(GeodataOrt.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von GeodataOrt: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(GeodataOrt other){
               other.setLatitude(this.latitude);
                  other.setLongitude(this.longitude);
                  other.setOrtsname(this.ortsname);
                  other.setOrtsteilname(this.ortsteilname);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(GeodataOrt other){
                       if (hasChangedLatitude) {
        other.setLatitude(this.latitude);
      }
                             if (hasChangedLongitude) {
        other.setLongitude(this.longitude);
      }
                             if (hasChangedOrtsname) {
        other.setOrtsname(this.ortsname);
      }
                             if (hasChangedOrtsteilname) {
        other.setOrtsteilname(this.ortsteilname);
      }
             }





    @javax.persistence.Transient
    private transient GeodataOrtTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public GeodataOrtTK getGeodataOrtTK(){
    if (tkCache==null) {
    tkCache = new GeodataOrtTK(

getOrtsname()
, getOrtsteilname()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getGeodataOrtTK();
    }

  @Override
  public GeodataOrtUK getUk(){
    return getGeodataOrtUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return GeodataOrt.class;
  }

public GeodataOrtUK getGeodataOrtUK(){

   return  new GeodataOrtUK(

getOrtsname()
, getOrtsteilname()


  );
}

  @javax.persistence.Transient
  private transient GeodataOrtProperties properties;

  public GeodataOrtProperties getProperties(){
    if (properties == null) {
      properties = new GeodataOrtProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public GeodataOrtProperties getGeodataOrtProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return GeodataOrtConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(GeodataOrtConstants.MESSAGE_KEY_LATITUDE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(GeodataOrtConstants.MESSAGE_KEY_LATITUDE_EINZAHL);

        latitude =
     vorher.getAttributTyp().getValueAsDouble(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(GeodataOrtConstants.MESSAGE_KEY_LONGITUDE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(GeodataOrtConstants.MESSAGE_KEY_LONGITUDE_EINZAHL);

        longitude =
     vorher.getAttributTyp().getValueAsDouble(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(GeodataOrtConstants.MESSAGE_KEY_ORTSNAME_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(GeodataOrtConstants.MESSAGE_KEY_ORTSNAME_EINZAHL);

        ortsname =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(GeodataOrtConstants.MESSAGE_KEY_ORTSTEILNAME_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(GeodataOrtConstants.MESSAGE_KEY_ORTSTEILNAME_EINZAHL);

        ortsteilname =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertLatitude) {
      result.put(GeodataOrtConstants.MESSAGE_KEY_LATITUDE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.DOUBLE
                , wertNachLadenLatitude , latitude));
    }
                            if (isSeitLadenVeraendertLongitude) {
      result.put(GeodataOrtConstants.MESSAGE_KEY_LONGITUDE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.DOUBLE
                , wertNachLadenLongitude , longitude));
    }
                            if (isSeitLadenVeraendertOrtsname) {
      result.put(GeodataOrtConstants.MESSAGE_KEY_ORTSNAME_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenOrtsname , ortsname));
    }
                            if (isSeitLadenVeraendertOrtsteilname) {
      result.put(GeodataOrtConstants.MESSAGE_KEY_ORTSTEILNAME_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenOrtsteilname , ortsteilname));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertLatitude = false;
      wertNachLadenLatitude = null;
                          isSeitLadenVeraendertLongitude = false;
      wertNachLadenLongitude = null;
                          isSeitLadenVeraendertOrtsname = false;
      wertNachLadenOrtsname = null;
                          isSeitLadenVeraendertOrtsteilname = false;
      wertNachLadenOrtsteilname = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "GEODATA_ORT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "GeodataOrt";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(GeodataOrtConstants.LATITUDE_MAX_VALUE, GeodataOrtConstants.LATITUDE_MIN_VALUE, latitude, this, GeodataOrtConstants.MESSAGE_KEY_LATITUDE_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(GeodataOrtConstants.LONGITUDE_MAX_VALUE, GeodataOrtConstants.LONGITUDE_MIN_VALUE, longitude, this, GeodataOrtConstants.MESSAGE_KEY_LONGITUDE_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(ortsname, this, GeodataOrtConstants.MESSAGE_KEY_ORTSNAME_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(GeodataOrtConstants.ORTSNAME_MAX_LENGTH , 1 ,  ortsname, this, GeodataOrtConstants.MESSAGE_KEY_ORTSNAME_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(GeodataOrtConstants.ORTSTEILNAME_MAX_LENGTH ,  ortsteilname, this, GeodataOrtConstants.MESSAGE_KEY_ORTSTEILNAME_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
